MagicResource.setup do |config|
  ## Uncoment the line to change the context to be used as default.
  ## Default value is `:crud`.
  # config.default_context = :manage

  ## Uncoment the line to change default form helper prefix.
  ## Default value is `:simple`.
  # config.default_form_type = :default

  ## Change the method to adjust the level or resource magic.
  ## possible methods are `no_magic`, `try_magic?` and `full_magic!`
  ## Thechnically such methods just setting all following parameters to
  ## `:by_exception`, `:by_warning` and `false` respectively.
  config.no_magic

  ############################
  #### For all next parameters
  #### the correct values are: `<%= MagicResource::MAGIC_VALID_VALUES.inspect %>`.

  ## Will require to specify the resource name in helper's pattern when resource is "other".
  ## Can be useful for fast development or experiments. But typically it's better
  ## to switch it off later and define the resource names everywhere,
  ## because the magic becames to be not predictable and searchable.
  # config.force_resource_name_definition = :by_exception

  ## Will require the correct resource assignation in controller
  ## Means the situation when inside Users::CrudController you trying to do
  ## self.resource = Property.first
  # config.assert_resource_name_in_controller = :by_exception

  ## Will disable content_for helper.
  ## It is too much magical...
  ## But in some cases it is the better than other solutions.
  ## Try to avoid it.
  ## Activate it if you really need it.
  # config.disable_content_for_helper = :by_exception

end
