RubyFeatures.define('magic_resource') do
  dependency 'activerecord_devkit/association_soft_build'

  apply_to 'ActionDispatch::Http::URL' do
    applied do |variable|
      class << self
        alias_method_chain :url_for, :http_verb
      end
    end

    class_methods do
      def url_for_with_http_verb(options, *args)
        path = url_for_without_http_verb(options, *args)
        options[:path].kind_of?(MagicResource::PathWithHttpVerb) ?
          MagicResource::PathWithHttpVerb.new(options[:path], path) :
          path
      end
    end
  end

  apply_to 'ActionDispatch::Journey::Route' do
    applied do
      alias_method_chain :format, :http_verb
    end

    instance_methods do
      def format_with_http_verb(*args)
        MagicResource::PathWithHttpVerb.new(self.verb, format_without_http_verb(*args))
      end
    end
  end

end.apply
